#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>
#include <stdio.h>

#define MAX_ELEMENTS 100
int itera=0;

/////////////////////////////////Definicion del stack///////////////////////////////////

typedef struct stack 
{
		int top;
		double element [MAX_ELEMENTS];
} STACK;

//funciones para el stack de nodos

void MakeNull_N(STACK *S) 
{
	S->top=-1;
}

int Stack_Empty_N(STACK * S)
{
	return (S->top == -1);
}

void Push_N( STACK *S, double x)
{
	double a,b,c,d;

	assert (S->top < MAX_ELEMENTS);
	(*S).top++;
	(*S).element[(*S).top]=x;
  	a=(*S).element[(*S).top-1];
	b=(*S).element[(*S).top-2];
	c=(*S).element[(*S).top-3];
	d=(*S).element[(*S).top-4];
	//cout<<"stack nodos--"<<x<<"--"<<a<<"--"<<b<<"--"<<c<<"--"<<d<<'\n'<<endl;
}

double Pop_N(STACK *S) 
{	
	assert((*S).top > -1);
	return((*S).element[(*S).top--]);
}

double Top_N(STACK *S) 
{
	assert(S->top > -1);
	return (S->element[S->top]);
} 

double Top_N_1(STACK *S) 
{
	assert(S->top > -1);
	return (S->element[S->top-1]);
} 

double Top_N_2(STACK *S) 
{
	assert(S->top > -1);
	return (S->element[S->top-2]);
} 

double Top_N_3(STACK *S) 
{
	assert(S->top > -1);
	return (S->element[S->top-3]);
}
/////////////////////////funciones para el stack de capacidades////////////////////////////////

void MakeNull_C(STACK *S) 
{
	S->top=-1;
}
													
int Stack_Empty_C(STACK *S)
{
	return (S->top == -1);
}

void Push_C( STACK *S, double x)
{
	double a,b,c,d;

	assert (S->top < MAX_ELEMENTS);
	(*S).top++;
	(*S).element[(*S).top]=x;
  	a=(*S).element[(*S).top-1];
	b=(*S).element[(*S).top-2];
	c=(*S).element[(*S).top-3];
	d=(*S).element[(*S).top-4];
}

double Pop_C(STACK *S) 
{	
	assert((*S).top > -1);  
	return((*S).element[(*S).top--]);
}

double Top_C(STACK *S) 
{										   
	assert(S->top > -1);
	return (S->element[S->top]);
}

//////////////////////////definicion de los 2 stack a ocupar///////////////////////////////	

STACK NODOS;  //stack de nodos
STACK CAP;	  //stack de capacidades

	double flujo[6][6];

////funcion anloga al algoritmo de Folk Fulkerson para calcular la red residual(RR)///////

int ford(int k, int porte, double capa[][/*resumidero+1*/6]) //k define el tamao del stack
{
	itera++;
	int n1=0,n2=0; //van a tomar los valores de los nodos,n1 es nodo fuente, n2 es nodo destino
	double c,cf=1,cc,ccc,cd;

	for(int con=0;con<k;con++) // se busca la capacidad menor para obtener el flujo adicional maximo (cf)
	{
		c=Pop_C(&CAP);
		if (c==20)
			return(20);
		if(c<cf)
		{
			cf=c;
		}
	}
	cout<<"Camino "<<itera<<":"<<endl;
	cout<<"---------\n"<<endl;
	for(int con2=0;con2<k;con2++) // se obtiene el camino de aumento y se le resta el (cf) a las capacidades para obtener la (RR)
	{
		n2= int(Pop_N(&NODOS));
		cout<<"Arco ("<<n1<<","<<n2<<"):"<<endl;
		cout<<"-----------"<<endl;

		ccc=flujo[n1][n2];
		cout<<"flujo inicial ("<<n1<<","<<n2<<"): "<<capa[n1][n2]<<'\n'<<endl;

		flujo[n1][n2]=flujo[n1][n2]+cf;
		capa[n1][n2]=capa[n1][n2]-cf;
		cc=flujo[n1][n2];
		cd=capa[n1][n2];

		cout<<"flujo ("<<n1<<","<<n2<<"): "<<cf<<'\n'<<endl;
		cout<<"capacidad residual ("<<n1<<","<<n2<<"): "<<cd<<'\n'<<endl;
		n1=n2;
	}
	cout<<"Presione enter para buscar el siguiente camino...\n"<<endl;
	getchar();
}  

//////////////funcion que entrega el camino de aumento (CDA) de 0 a 5////////////////////
 
void camino(int tam, double cap[][/*resumidero+1*/6], double cap2[][/*resumidero+1*/6])
{
	double flujo2[tam][tam];
	int cont=0,term;
	int j=5,z,h,g,p=10,m=0,e=10,q=10,r=10,k=0;
	double s=1,f,ff,fmax=0;	
	double w,o;

	while(cont<6)
	{
		j=5;
		p=10;
		q=10;
		r=10;
		m=0;
		e=10;
		k=0;
		s=20;
	
		MakeNull_N(&NODOS);	//vacio los stack para evitar errores
		MakeNull_C(&CAP);
  
  
  
		while(j!=0) //se busca el camino de manera inversa hasta llegar del 5 al 0
		{
			for(int i=tam-2;i>=0;i--)
			{
				if(cap[i][j]<=s && cap[i][j]!=1 && cap[i][j]!=0 && i!=e && (j!=p || j==0 || i==0)  && (j!=q || j==0 || i==0) && (j!=r || j==0 || i==0))
				{ 

/////////condiciones necesarias para que no ocurran errores en la busqueda del (CDA)//////////
		
					s=cap[i][j];//se asigna el valor de la capacidad menor que entra al nodo destino,para luego ingresarla al stack
					h=j;
					g=i;
				}	
			}
			
			if (g!=j)//si existe camino puedo ingresar el nodo y la capacidad a los stack
			{
				Push_N(&NODOS,h);
				Push_C(&CAP,s);
				s=1;	
				j=g;
				p=int (Top_N_1(&NODOS));
				q=int (Top_N_2(&NODOS));
				r=int (Top_N_3(&NODOS));
				k++;
			}

			else//si no existe camino me devuelvo al nodo anterior y busco otro camino
			{																	 
				e=j;
 				j=int (Pop_N(&NODOS));  
				o=Pop_C(&CAP);
				s=1;	
				g=j;
				k--;
			}
		}

		term=ford(k,tam,cap); //con el camino de aumento ya obtenido,llamo a la funcion para obtener la red residual y le entrego el tamao de los stack en la variable k
		cont++;
		if(term==20)//si no hay mas caminos de aumento se sale del while y el programa muestra los resultados finales	
		{		 	
			cout<<"No existen mas caminos, Red de Flujo Maximo:\n"<<endl;	
			cout<<"\t\t  (Flujo Arco --> Cap. Utilizada / Cap Total)"<<'\n'<<endl;
	
			for(int i=0;i<tam;i++) //rutea las matrices de capacidad y flujo para mostrar los resultados obtenidos 
			{
				for(int j=0;j<tam;j++)
				{
					if(cap2[i][j]!=1)
					{
						f=flujo[i][j];
						ff=cap2[i][j];
						fmax=fmax+flujo[i][tam-1];
						cout<<"\t\t\tFlujo Arco ("<<i<<","<<j<<") ---> "<<f<<" / "<<ff<<"\n"<<endl;
					}
				}
			}
		
			cout<<"\t\t\t\t\t\t\tFlujo Maximo (0,"<<tam-1<<") --> "<<fmax/2<<endl;
			exit(0);
		}
	}
}
 
double findval(int a, int b, vector<int> x, vector<int> y, vector<double> p)//encuentra el valor de peso para ser asignado a la matriz de pesos
{
	for(int z=0;z<x.size();z++)
	{
		if((x[z]==a)&&(y[z]==b))
			return p[z];
	}
	return 0;//si no existe el peso para el arco buscado, se asume que no esta conectado, y se retorna un 0
}

void main(int argc,char * argv[])
{
	for(int i=0;i<6;i++)//inicializacion de la matriz de flujos
	{
		for(int j=0;j<6;j++)
		{
			flujo[i][j]=0;
		}
	}

	system("clear");
	vector<string> svnodoi;
	vector<string> svnodof;
	vector<string> svpesos;

	vector<int> vnodoi;
	vector<int> vnodof;
	vector<double> vpesos;

	ifstream grafo;
	ofstream resultado;
	string nodoi;
	string nodof;
	string pesos;
	string aux;
	int number=0;
	double numberf=0;
	double result=0;

/////////////////////////Error al llamar al programa///////////////////////
	
	if(argc!=2)
	{
		cerr<<"Uso: eda5 <archivo.txt>"<<endl;
		return 0;
	}

////////////////////////llamada al programa correcta////////////////////////////////////////

	else if(argc==2)
	{
		grafo.open(argv[1]);

		while(!grafo.eof())
		{
			grafo>>nodoi;
			grafo>>nodof;
			grafo>>pesos;

			svnodoi.push_back(nodoi);
			svnodof.push_back(nodof);
			svpesos.push_back(pesos);
		}

///////////cambio a enteros el numero de nodo inicial leido por el archivo/////////////////

		for(int i=0;i<svnodoi.size()-1;i++,number=0)
		{
			aux=svnodoi[i];

			for(int j=0;j<aux.length();j++)
			{
				number=number*10+aux[j]-'0';			
			}
			vnodoi.push_back(number);
		}

		cout<<"\n<<Vector de nodos iniciales>>"<<endl;

		for(int i=0;i<vnodoi.size();i++)//ojo size-1
			cout<<vnodoi[i]<<" ";

		cout<<endl;
		number=0;

///////////cambio a enteros el numero de nodo final leido por el archivo////////////////////

		for(int i=0;i<svnodof.size()-1;i++,number=0)
		{
			aux=svnodof[i];

			for(int j=0;j<aux.length();j++)
			{
				number=number*10+aux[j]-'0';			
			}
			vnodof.push_back(number);
		}

		cout<<"\n<<Vector de nodos finales>>"<<endl;

		for(int i=0;i<vnodof.size();i++)//ojo size-1
			cout<<vnodof[i]<<" ";

		cout<<endl;

///////////cambio a enteros el peso leido por el archivo////////////////////

		for(int i=0;i<svpesos.size()-1;i++,numberf=0)
		{
			aux=svpesos[i];

			if((aux=="1")||(aux=="1.00")||(aux=="1.0"))
			{
				vpesos.push_back(1);
				goto ok;
			}

			else if((aux=="0")||(aux=="0.00")||(aux=="0.0"))
			{
				vpesos.push_back(0);
				goto ok;
			}

			for(int j=2;j<aux.length();j++)
			{
				numberf=numberf*10+aux[j]-'0';			
			}
			numberf=numberf/100;
			vpesos.push_back(numberf);
ok:;
		}

		cout<<"\n<<Vector de pesos>>"<<endl;

		for(int i=0;i<vpesos.size();i++)//ojo size-1
			cout<<vpesos[i]<<" ";

		cout<<endl;

//////////////////////////////////Encontrar punto inicio y dest//////////////////////

		int fuente=0;
		int max1=vnodoi[0];
		int max2=vnodof[0];
		int resumidero;
		for(int i=0;i<vnodoi.size();i++)
		{
			if(vnodoi[i]>max1)
				max1=vnodoi[i];
		}

		for(int i=0;i<vnodof.size();i++)
		{
			if(vnodof[i]>max2)
				max2=vnodof[i];
		}

		if(max1>max2)
			resumidero=max1;
		else
			resumidero=max2;

		cout<<"\nFuente: 0"<<endl;

		cout<<"\nResumidero: "<<resumidero<<endl;

/////////////////////////////////Crea Matriz y llenarla de 1's////////////////////////

		double matrix[resumidero+1][/*resumidero+1*/6];

		cout<<"\nMatriz de Entrada es de "<<resumidero+1<<" x "<<resumidero+1<<endl;

		for(int x=0;x<resumidero+1;x++)
		{
			for(int y=0;y<resumidero+1;y++)
			{
				matrix[x][y]=1;
			}
		}

///////////////////////////////Lleno matriz con pesos///////////////////////////////

		for(int x=0;x<vnodoi.size();x++)
		{
			for(int y=0;y<vnodof.size();y++)
			{

				result=findval(x,y,vnodoi,vnodof,vpesos);

				if(result!=0)
					matrix[x][y]=result;
			}
		}

///////////////////////////////Muestro resultados de la matriz//////////////////////

////////////////////////Titulo y "eje x"//////////////////////////////////////////////

		cout<<"\n\n     <<Matriz de Entrada>>\n"<<endl;

		cout<<"  f";
		for(int x=0;x<resumidero+1;x++)
			cout<<x<<"    ";

		cout<<"\ni"<<endl;

//////////////////////elementos de la matriz en posicion correspondiente/////////////

		for(int y=0;y<resumidero+1;y++,cout<<"\n")
		{
			cout<<y<<"  ";//para indicar el "eje y"

			for(int x=0;x<resumidero+1;x++)
			{
				if((matrix[y][x]==0)||(matrix[y][x]==1))
					cout<<0<<"    ";
				else
					cout<<matrix[y][x]<<" ";
			}
		}
		cout<<endl;
		int test=resumidero+1;
		double matriz[resumidero+1][/*resumidero+1*/6];

		for(int i=0;i<resumidero+1;i++)
		{
			for(int j=0;j<resumidero+1;j++)
			{
				matriz[i][j]=matrix[i][j];
			}
		}
		cout<<"Presione Enter para comenzar la ejecucion del programa..."<<endl;
		getchar();
///////////////////////////////matrix tiene el grafo de entrada///////////////////////
		camino(test,matrix,matriz);
	}
}

		

